$!helo!
$!++
$!
$!  file:	shdev.com
$!  author:	Maulis Adam
$!  cre.date:	23-JUN-1999
$!  version:	1.2
$!
$!    This program is free software; you can redistribute it and/or modify
$!    it under the terms of the GNU General Public License version 2 as 
$!    published by the Free Software Foundation.
$!
$!
$!--
$	say = "write sys$output"
$
$	IF P1 .nes. ""
$	THEN
$	   If .not. f$getdvi(P1,"EXISTS") then p1 = f$device("*"+p1+"*","DISK")
$	   if p1 .eqs. ""
$	   THEN
$	      say "%SHDEV-E-NOTDISK, ",p1," is not an existent disk device"
$	      EXIT
$	   ENDIF
$	   dev = f$getdvi(P1,"FULLDEVNAM")
$	   if f$device(dev,"DISK") .eqs. ""
$	   then
$	      say "%SHDEV-E-NODISK, ",dev," is not a disk device"
$	      EXIT
$	   endif
$	   say "Device       Type       Label         Freeblocks  Used    Total   Trans/RefCNT" 
$	   if .not. f$getdvi(dev,"MNT")
$	   then
$	      say f$fao("!13<!AS!>!8<!AS!>   not mounted ",dev,f$getdvi(dev,"MEDIA_NAME"))
$	      EXIT
$	   endif
$	   if  f$getdvi(dev,"ALL") ! allocated
$	   then
$	      say f$fao("!13<!AS!>!8<!AS!> mounted alloc to !AS", -
                  dev,f$getdvi(dev,"MEDIA_NAME"),f$getdvi(dev,"PID"))
$	      EXIT
$	   endif
$	   dev = f$getdvi(f$getdvi(dev,"ROOTDEVNAM"),"FULLDEVNAM")	! works both volset and shadow
$	   CALL PRINT_ONE_DEV 'dev'
$	   EXIT
$	ENDIF
$
$	say "Device       Type       Label         Freeblocks  Used    Total   Trans/RefCNT" 
$ MAIN_LOOP:
$	dev = f$device(,"DISK")
$	if dev .eqs. "" then GOTO end_main_loop
$	devtype= f$getdvi(dev,"DEVTYPE")
$       ! unknown, or not identified or volumeset
$	if devtype .eq. 0 .or. devtype .eq. 35 then GOTO main_loop
$	if .not. f$getdvi(dev,"MNT")
$	then
$	   say f$fao("!13<!AS!>!8<!AS!>   not mounted ",dev,f$getdvi(dev,"MEDIA_NAME"))
$	   GOTO main_loop
$	endif
$	if  f$getdvi(dev,"ALL") ! allocated
$	then
$	   say f$fao("!13<!AS!>!8<!AS!> mounted alloc to !AS", -
                  dev,f$getdvi(dev,"MEDIA_NAME"),f$getdvi(dev,"PID"))
$	GOTO main_loop
$	endif
$	if f$getdvi(dev,"ROOTDEVNAM") .nes. f$getdvi(dev,"DEVNAM") then GOTO main_loop
$	if f$getdvi(dev,"SHDW_MEMBER") then GOTO main_loop
$	CALL PRINT_ONE_DEV 'dev'
$	GOTO main_loop
$ END_MAIN_LOOP:
$
$ EXIT
$
$	!++
$	!
$	!	Subroutine section
$	!
$	!--
$
$ PRINT_ONE_DEV: SUBROUTINE
$	_dev=P1
$	free =0 
$	summ =0
$	transcnt= 0
$	refcnt = 0
$ VOLSET_LOOP:
$	summ = summ + f$getdvi(_dev,"MAXBLOCK")
$	free = free + f$getdvi(_dev,"FREEBLOCKS")
$	transcnt = transcnt+f$getdvi(_dev,"TRANSCNT")
$	refcnt = refcnt + f$getdvi(_dev,"REFCNT")
$	nextdev = f$getdvi(_dev,"NEXTDEVNAM")
$	if nextdev .eqs. "" then GOTO end_volset_loop
$	_dev=nextdev
$	GOTO volset_loop
$ END_VOLSET_LOOP:
$	! errcnt
$	! logvolnam
$	! maxblock
$	! freeblocks
$	used = summ-free
$	perc1 = used*10/summ
$	perc2 = (used*10 - (summ*perc1))*10/summ
$	outstr1=f$fao("!13<!AS!>!8<!AS!>!16<!AS!>", -
		p1,f$getd(p1,"MEDIA_NAME"),f$getd(p1,"VOLNAM"))
$	outstr2=f$fao("!11UL !2UL!1UL% !11UL !5UL/!6<!UL!>",  -
		free, perc1,perc2,summ,transcnt,refcnt)
$	say outstr1,outstr2
$	
$	EXIT
$ ENSUBROUTINE
